require 'menu'
require 'ground'
require 'player'
require 'obstacle'
require 'score'
require 'gameover'

function love.load()
	-- Sets the current gamestate to menu.
	gamestate = 'menu'
	-- Loads all needed assets and variables.
	menu_load()
	ground_load()
	player_load()
	obstacle_load()
	score_load()
	gameover_load()
end

function love.update(dt)
	-- If the gamestate is the game, we then go to the game.
	if gamestate == 'game' then
		ground_update()
		player_update(dt)
		obstacle_update(dt)
		score_update()
	end
	-- If the gamestate is gameover, we then go to the gameover.
	if gamestate == 'gameover' then
		gameover_update()
	end

end

function love.draw()
	-- If gamestate is menu, we go to the menu.
	if gamestate == 'menu' then
		menu_draw()
	end
	-- If the gamestate is tgame, we go to the game.
	if gamestate == 'game' then
		ground_draw()
		player_draw()
		obstacle_draw()
		score_draw()
	end
	-- If the gamestate is gameover, we go to the gameover screen.
	if gamestate == 'gameover' then
		gameover_draw()
	end
end

function love.keypressed(key)
	-- Controls for Menu State.
	if gamestate == 'menu' then
		-- For starting a new game.
		if key == 'return' then
			gamestate = 'game'
		-- For quitting game.
		elseif key == 'escape'then
			love.event.quit()
		end
	end
	-- Controls for Game State.
	if gamestate == 'game' then
		-- For jumping.
		if key == 'space' and player.isJumping == 'false' then
			player.isJumping = 'true'
			if player.y_velocity == 0 then
				player.y_velocity = player.jump_height
			end
		end
		-- For dashing.
		if player.canDash <= 0 then
			if key == 'z' and player.isJumping == 'true' then
				player.canDash = player.maxCanDash
				player.isDashing = 'true'
				player.y_velocity = 0
			end
		end
		-- For dash canceling.
		if player.isDashing == 'true' and player.isJumping == 'true' then
			if key == 'x' then
				player.isDashing = 'false'
				player.isDashCanceling = 'true'
				player.airTime = 0
			end
		end
	end
	-- Controls for Gameover State.
	if gamestate == 'gameover' then
		-- For restarting.
		if key == 'r' then
			gamestate = 'game'
		end
		-- For quitting to menu.
		if key == 'escape' then
			gamestate = 'menu'
		end
	end
end