function obstacle_load()
  skelPits = {}
  trees = {}

  lastTimeSkelPit = 250
  lastTimeTree = 350
end

function obstacle_update(dt)
  -- Generates skelPits.
	lastTimeSkelPit = lastTimeSkelPit - 1.5
	if lastTimeSkelPit <= 0 then
		-- Makes a random number between 40 - 175 to serve as the last time skelPit was generated.
		lastTimeSkelPit = love.math.random(40, 225)

 		-- Details of the newly created skelPit.
		newSkelPit = { x = 800, y = 345, width = 275, height = 55}
		table.insert(skelPits, newSkelPit)
	end
	-- Moves skelPits.
	for i, skelPit in ipairs(skelPits) do
		skelPit.x = skelPit.x - 900 * dt
		-- skelPit off screen gets removed.
		if skelPit.x < 0 then
			table.remove(skelPit, i)
		end
	end

	-- Checks collision of skelPit and player.
	for i, skelPit in ipairs(skelPits) do
		if collisionObstacle(player.x, player.y, player.w, player.h, skelPit.x, skelPit.y, skelPit.width, skelPit.height) then
			gamestate = 'gameover'
		end
	end

  -- Generates trees.
  lastTimeTree = lastTimeTree - 0.5
  if lastTimeTree <= 0 then
    -- Makes a random number between 40 - 275 to serve as the last time tree was generated.
    lastTimeTree = love.math.random(40, 175)

    -- Details of the newly created tree.
    newTree = { x = 800, y = 200, width = 150 , height = 25}
    table.insert(trees, newTree)
  end

  -- Moves trees.
  for i, tree in ipairs(trees) do
    tree.x = tree.x - 900 * dt
    -- Tree off screen gets removed.
      if tree.x < 0 then
        table.remove(tree, i)
      end
    end

  -- Checks collision of skelPit and player.
  for i, tree in ipairs(trees) do
      if collisionObstacle(player.x, player.y, player.w, player.h, tree.x, tree.y, tree.width, tree.height) then
        gamestate = 'gameover'
      end
  end

end

function obstacle_draw()
  -- Draws skelPits
  for i, skelPit in ipairs(skelPits) do
    love.graphics.setColor(255, 0, 0)
    love.graphics.rectangle('fill', skelPit.x, skelPit.y, skelPit.width, skelPit.height)
  end
  -- Draws trees
  for i, tree in ipairs(trees) do
		love.graphics.setColor(0, 255, 0)
		love.graphics.rectangle('fill', tree.x, tree.y, tree.width, tree.height)
	end
end

function collisionObstacle (x1,y1,w1,h1, x2,y2,w2,h2)
	return x1 < x2+w2 and
        x2 < x1+w1 and
        y1 < y2+h2 and
        y2 < y1+h1
end
